SystemOrganization addCategory: #'ObjectAsMethodWrapper-Dummies'!
SystemOrganization addCategory: #'ObjectAsMethodWrapper-Tests'!
SystemOrganization addCategory: #ObjectAsMethodWrapper!

Object subclass: #ObjectAsMethodWrapper
	instanceVariableNames: 'wrappedClass selector oldMethod preblock postblock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectAsMethodWrapper'!

!ObjectAsMethodWrapper commentStamp: 'cyrille.delaunay 3/23/2009 11:24' prior: 0!
This class implements methodWrapper like behavior using the trick that the VM allows any object to be put in 
a method dictionary if it implements run:with:in:


Here is a way to install a methodWrapper.

((PackageInfo named: 'Morphic') classes gather: [ :each | 
	ObjectAsOneTimeMethodWrapper installOnClass: each ]) inspect

((PackageInfo named: 'Morphic') classes do: [:each|ObjectAsMethodWrapper uninstallClass: each ]) 


Possible improvements:
	- it is not clear that specifying pre and post action is better than a simple method as in the original MethodWrapper
	implementation. !

ObjectAsMethodWrapper subclass: #ObjectAsCountingTimeMethodWrapper
	instanceVariableNames: 'counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectAsMethodWrapper'!

!ObjectAsCountingTimeMethodWrapper class methodsFor: 'examples' stamp: 'mga 3/25/2004 21:57'!
examplePixelValueAt
	self installOn: Form selector: #pixelValueAt:! !

!ObjectAsCountingTimeMethodWrapper methodsFor: 'testing' stamp: 'sd 4/7/2009 17:48'!
counter

	^ counter! !

!ObjectAsCountingTimeMethodWrapper methodsFor: 'testing' stamp: 'sd 4/7/2009 17:49'!
executed

	^ counter > 0 ! !

!ObjectAsCountingTimeMethodWrapper methodsFor: 'initialize' stamp: 'stephane.ducasse 3/9/2009 22:18'!
initialize
	super initialize.
	counter := 0.
	postblock := [:aSel :someArgs :aRec | counter := counter+1]! !

!ObjectAsMethodWrapper class methodsFor: 'instance creation' stamp: 'mga 1/7/2004 00:07'!
installOn: aClass selector: aSel
	^(self on: aClass selector: aSel) install;yourself! !

!ObjectAsMethodWrapper class methodsFor: 'instance creation' stamp: 'mga 1/7/2004 18:12'!
installOnClass: aClass
	|someWrappers|
	someWrappers:=OrderedCollection new.
	aClass selectors do: [:aSymbol | someWrappers add: (self installOn: aClass selector: aSymbol)].
	aClass class selectors do: [:aSymbol | someWrappers add: (self installOn: aClass class selector: aSymbol)].
	^someWrappers! !

!ObjectAsMethodWrapper class methodsFor: 'instance creation' stamp: 'mga 1/7/2004 17:35'!
installOnClassCategory: aString
	|someWrappers|
	someWrappers:= OrderedCollection new.
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		someWrappers addAll: (self installOnClass: (Smalltalk classNamed: aClassName)).
		].
	^someWrappers
	! !

!ObjectAsMethodWrapper class methodsFor: 'instance creation' stamp: 'mga 1/7/2004 00:08'!
on: aClass selector: aSel
	^self new initializeFor: aClass selector: aSel! !

!ObjectAsMethodWrapper class methodsFor: 'instance creation' stamp: 'mga 1/7/2004 17:50'!
uninstallClass: aClass
	aClass methodDict values do: [:e | (e isKindOf: self) ifTrue: [e uninstall]].
	aClass class methodDict values do: [:e | (e isKindOf: self) ifTrue: [e uninstall]].! !

!ObjectAsMethodWrapper class methodsFor: 'instance creation' stamp: 'mga 1/7/2004 18:52'!
uninstallClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!ObjectAsMethodWrapper class methodsFor: 'instance creation' stamp: 'mga 1/7/2004 18:52'!
uninstallOnClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!ObjectAsMethodWrapper methodsFor: 'testing' stamp: 'mga 1/7/2004 19:24'!
doesNotUnderstand: aMessage

	^ oldMethod isNil
		ifTrue: [super doesNotUnderstand: aMessage]
		ifFalse: [oldMethod perform: aMessage selector withArguments: aMessage arguments]! !

!ObjectAsMethodWrapper methodsFor: 'action' stamp: 'mga 1/7/2004 00:29'!
flushCache
	! !

!ObjectAsMethodWrapper methodsFor: 'initializing' stamp: 'stephane.ducasse 3/9/2009 22:16'!
initialize
	preblock := [:aSel :someArgs :aRec | nil].
	postblock := [:aSel :someArgs :aRec | nil].! !

!ObjectAsMethodWrapper methodsFor: 'initializing' stamp: 'stephane.ducasse 3/9/2009 22:16'!
initializeFor: aClass selector: aSel
	wrappedClass := aClass.
	selector := aSel! !

!ObjectAsMethodWrapper methodsFor: 'action' stamp: 'stephane.ducasse 3/9/2009 22:17'!
install
	[oldMethod := wrappedClass lookupSelector: selector.
	oldMethod isKindOf: self class] whileTrue: [oldMethod uninstall].
	wrappedClass addSelector: selector withMethod: self ! !

!ObjectAsMethodWrapper methodsFor: 'accessing' stamp: 'mga 1/7/2004 14:28'!
oldMethod
	"Answer the value of oldMethod"

	^ oldMethod! !

!ObjectAsMethodWrapper methodsFor: 'accessing' stamp: 'stephane.ducasse 3/9/2009 22:16'!
oldMethod: anObject
	"Set the value of oldMethod"

	oldMethod := anObject! !

!ObjectAsMethodWrapper methodsFor: 'accessing' stamp: 'mga 1/7/2004 14:28'!
postblock
	"Answer the value of postblock"

	^ postblock! !

!ObjectAsMethodWrapper methodsFor: 'accessing' stamp: 'stephane.ducasse 3/9/2009 22:16'!
postblock: anObject
	"Set the value of postblock"

	postblock := anObject! !

!ObjectAsMethodWrapper methodsFor: 'accessing' stamp: 'mga 1/7/2004 14:28'!
preblock
	"Answer the value of preblock"

	^ preblock! !

!ObjectAsMethodWrapper methodsFor: 'accessing' stamp: 'stephane.ducasse 3/9/2009 22:16'!
preblock: anObject
	"Set the value of preblock"

	preblock := anObject! !

!ObjectAsMethodWrapper methodsFor: 'action' stamp: 'stephane.ducasse 3/9/2009 22:17'!
run: aSelector with: arguments in: aReceiver

	| aResult |
	preblock value: aSelector value: arguments value: aReceiver.
	aResult := oldMethod valueWithReceiver: aReceiver arguments: arguments.
	postblock value: aSelector value: arguments value: aReceiver.
	^aResult
	! !

!ObjectAsMethodWrapper methodsFor: 'accessing' stamp: 'mga 1/7/2004 00:08'!
selector
	"Answer the value of selector"

	^ selector! !

!ObjectAsMethodWrapper methodsFor: 'accessing' stamp: 'stephane.ducasse 3/9/2009 22:16'!
selector: anObject
	"Set the value of selector"

	selector := anObject! !

!ObjectAsMethodWrapper methodsFor: 'action' stamp: 'fbs 8/23/2012 14:03'!
uninstall
	| category |
	oldMethod isNil ifTrue: [^self].
	category := wrappedClass organization categoryOfElement: selector.
	wrappedClass removeSelectorSilently: selector.
	wrappedClass addSelector: selector withMethod: oldMethod. 
	wrappedClass organization classify: selector under: category.! !

!ObjectAsMethodWrapper methodsFor: 'accessing' stamp: 'mga 1/7/2004 00:09'!
wrappedClass
	"Answer the value of wrappedClass"

	^ wrappedClass! !

!ObjectAsMethodWrapper methodsFor: 'accessing' stamp: 'stephane.ducasse 3/9/2009 22:16'!
wrappedClass: anObject
	"Set the value of wrappedClass"

	wrappedClass := anObject! !

ObjectAsMethodWrapper subclass: #ObjectAsOneTimeMethodWrapper
	instanceVariableNames: 'executed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectAsMethodWrapper'!

!ObjectAsOneTimeMethodWrapper methodsFor: 'accessing' stamp: 'mga 1/7/2004 15:03'!
executed
	"Answer the value of executed"

	^ executed! !

!ObjectAsOneTimeMethodWrapper methodsFor: 'accessing' stamp: 'fbs 8/23/2012 09:36'!
executed: anObject
	"Set the value of executed"

	executed := anObject! !

!ObjectAsOneTimeMethodWrapper methodsFor: 'initializing' stamp: 'stephane.ducasse 3/9/2009 22:19'!
initialize

	super initialize.
	executed := false! !

!ObjectAsOneTimeMethodWrapper methodsFor: 'action' stamp: 'stephane.ducasse 3/9/2009 22:19'!
run: aSelector with: arguments in: aReceiver

	| aRes |
	aRes := super run: aSelector with: arguments in: aReceiver.
	[self executed: true]
		ensure: [self uninstall].
	^aRes! !

Object subclass: #ObjectAsMethodWrapperDummy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectAsMethodWrapper-Dummies'!

!ObjectAsMethodWrapperDummy methodsFor: 'as yet unclassified' stamp: 'mga 1/7/2004 14:04'!
bar
	^ 2! !

!ObjectAsMethodWrapperDummy methodsFor: 'as yet unclassified' stamp: 'mga 1/7/2004 01:01'!
foo
	^ 1! !

TestCase subclass: #ObjectAsOneTimeMethodWrapperTest
	instanceVariableNames: 'preExecuted postExecuted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectAsMethodWrapper-Tests'!

!ObjectAsOneTimeMethodWrapperTest methodsFor: 'accessing' stamp: 'mga 1/7/2004 14:28'!
postExecuted
	"Answer the value of postExecuted"

	^ postExecuted! !

!ObjectAsOneTimeMethodWrapperTest methodsFor: 'accessing' stamp: 'fbs 8/23/2012 09:37'!
postExecuted: anObject
	"Set the value of postExecuted"

	postExecuted := anObject! !

!ObjectAsOneTimeMethodWrapperTest methodsFor: 'accessing' stamp: 'mga 1/7/2004 14:28'!
preExecuted
	"Answer the value of preExecuted"

	^ preExecuted! !

!ObjectAsOneTimeMethodWrapperTest methodsFor: 'accessing' stamp: 'fbs 8/23/2012 09:37'!
preExecuted: anObject
	"Set the value of preExecuted"

	preExecuted := anObject! !

!ObjectAsOneTimeMethodWrapperTest methodsFor: 'running' stamp: 'mga 1/7/2004 16:10'!
testInstallOn
	"self run: #testInstallOn"
	|aWrapper|
	aWrapper := ObjectAsOneTimeMethodWrapper installOn: ObjectAsMethodWrapperDummy selector: #foo.
	aWrapper preblock: [:aSel :someArgs :aRec | self preExecuted:true].
	aWrapper postblock: [:aSel :someArgs :aRec | self postExecuted:true].
	[self assert: (ObjectAsMethodWrapperDummy new foo = 1).
	self assert: aWrapper executed.
	self assert: preExecuted.
	self assert: postExecuted] ensure: [aWrapper uninstall].
	^aWrapper! !

!ObjectAsOneTimeMethodWrapperTest methodsFor: 'running' stamp: 'mga 2/12/2004 10:18'!
testInstallOnClassCategory
	"self run: #testInstallOnClassCategory"
	| someWrappers |
	someWrappers := ObjectAsOneTimeMethodWrapper installOnClassCategory: 'ObjectAsMethodWrapper-Dummies'.
	[self assert: (ObjectAsMethodWrapperDummy new foo = 1).
	self assert: (someWrappers anySatisfy: [:e | e executed not]).
	self assert: (ObjectAsMethodWrapperDummy new bar = 2).
	self assert: (someWrappers allSatisfy: [:e | e executed])] ensure: [someWrappers do: [:e | e uninstall]].
	^someWrappers! !

!ObjectAsOneTimeMethodWrapperTest methodsFor: 'running' stamp: 'fbs 8/23/2012 10:31'!
testUninstallLeavesClassOrganizationInWorkingState
	"self run: #testUninstallLeavesClassOrganizationInWorkingState"
	|aWrapper|
	aWrapper := ObjectAsOneTimeMethodWrapper
		installOn: ObjectAsMethodWrapperDummy
		selector: #foo.
	aWrapper uninstall.
	self assert: (ObjectAsMethodWrapperDummy organization allMethodSelectors includes: #foo).
	^aWrapper! !

!CompiledMethod methodsFor: '*ObjectAsMethodWrapper' stamp: 'sd 4/7/2009 22:02'!
uninstall
	"does nothing but now a compiled method is a bit more polymorphic with anObjectAsWrapper"
	! !

!Class methodsFor: '*ObjectAsMethodWrapper' stamp: 'mga 1/7/2004 18:39'!
unwrapAllMethods
	^ObjectAsMethodWrapper uninstallClass: self! !

!Class methodsFor: '*ObjectAsMethodWrapper' stamp: 'mga 1/7/2004 17:37'!
wrapAllMethods
	^ObjectAsOneTimeMethodWrapper installOnClass: self! !

!Class methodsFor: '*ObjectAsMethodWrapper' stamp: 'mga 1/7/2004 18:17'!
wrappedMethods
	|someMethods|
	someMethods:= Set new.
	someMethods addAll: (self methodDictionary values select: [:e | e isKindOf: ObjectAsMethodWrapper ]).
	someMethods addAll: (self class  methodDictionary values select: [:e | e isKindOf: ObjectAsMethodWrapper ]).
	^someMethods! !
